PROGRAM AFC2BF
! *** EXAMPLE OF ZFC2FB AND ZFC2BF ***
PARAMETER (NX=5,NY=4,LX=5,LY=4)
COMPLEX*16 C(LX,LY)
INTEGER*8 plan

include 'fftw3.f'

! **** INPUT ****
IERR=0
DO 20 J=1,NY
DO 10 I=1,NX
C(I,J)= DCMPLX(DBLE(I+J), DBLE(I*J)/DBLE(NX*NY))
10 CONTINUE
20 CONTINUE
WRITE(6,1000)
WRITE(6,1010) NX,NY,LX,LY
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
! **** OUTPUT ****
WRITE(6,1040)
! **** INITIALIZATION + FORWARD TRANSFORM ****
CALL DFFTW_PLAN_DFT_2D(plan,NX,NY,C,C,FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(plan)
CALL DFFTW_DESTROY_PLAN(plan)
! **** NORMALIZATION ****
DO 40 J=1,NY
DO 30 I=1,NX
C(I,J)=C(I,J)/DBLE(NX*NY)
30 CONTINUE
40 CONTINUE
WRITE(6,1050) IERR
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
! **** BACKWARD TRANSFORM ****
CALL DFFTW_PLAN_DFT_2D(plan,NX,0,C,C,FFTW_BACKWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(plan)
CALL DFFTW_DESTROY_PLAN(plan)
WRITE(6,1060) IERR
WRITE(6,1020)
WRITE(6,1030) ((C(I,J),J=1,NY),I=1,NX)
CALL DFFTW_CLEANUP()
STOP
!
! **** FORMAT ****
!
1000 FORMAT(1X,'*** ZFC2FB AND ZFC2BF ***'// &
 1X,' ** INPUT **'/)
1010 FORMAT(1X,' NX =',I3,' NY =',I3/ &
 1X,' LX =',I3,' LY =',I3/)
1020 FORMAT(1X,' C(IX,IY)')
1030 FORMAT(4(1X,' (',F6.3,',',F6.3,')'))
1040 FORMAT(/1X,' ** OUTPUT **')
1050 FORMAT(/1X,' ( FORWARD TRANSFORM )'/ &
 /1X,' IERR =',I4/)
1060 FORMAT(/1X,' ( BACKWARD TRANSFORM )'/ &
 /1X,' IERR =',I4/)
END
