PROGRAM AFC1BF
use MKL_DFTI
! *** EXAMPLE OF ZFC1FB AND ZFC1BF ***
IMPLICIT DOUBLE PRECISION (A-H,O-Z)
COMPLEX*16,allocatable :: C(:)
type(DFTI_DESCRIPTOR), POINTER :: My_Desc1_Handle
INTEGER N
INTEGER status

! **** INPUT ****
IERR=0
READ(5,*) N
ALLOCATE(C(N))
READ(5,*) (C(I),I=1,N)
WRITE(6,1000) N,N
WRITE(6,2000)
WRITE(6,2100) (I,DBLE(C(I)),I,DIMAG(C(I)),I=1,N)
! **** OUTPUT ****
WRITE(6,1100)
! **** FORWARD TRANSFORM ****
status=DftiCreateDescriptor(My_Desc1_Handle,DFTI_DOUBLE,DFTI_COMPLEX,1,0)
status=DftiCommitDescriptor(My_Desc1_Handle)
status=DftiComputeForward(My_Desc1_Handle,C)
status=DftiFreeDescriptor(My_Desc1_Handle)
! **** NORMALIZATION ****
DO 20 I = 1,N
C(I) = C(I)/DBLE(N)
20 CONTINUE
WRITE(6,1200)
WRITE(6,1400) IERR
WRITE(6,2000)
WRITE(6,2100) (I,DBLE(C(I)),I,DIMAG(C(I)),I=1,N)
! **** BACKWARD TRANSFORM ****
status=DftiCreateDescriptor(My_Desc1_Handle,DFTI_DOUBLE,DFTI_COMPLEX,1,N)
status=DftiCommitDescriptor(My_Desc1_Handle)
status=DftiComputeBackward(My_Desc1_Handle,C)
status=DftiFreeDescriptor(My_Desc1_Handle)
WRITE(6,1300)
WRITE(6,1400) IERR
WRITE(6,2000)
WRITE(6,2100) (I,DBLE(C(I)),I,DIMAG(C(I)),I=1,N)
STOP
! **** FORMAT ****
1000 FORMAT(1X,'*** ZFC1FB AND ZFC1BF ***'// &
 1X,' ** INPUT **'// &
 1X,' LD = ',I2// &
 1X,' INPUT DATA'// &
 1X,' N = ',I2/)
1100 FORMAT(//1X,' ** OUTPUT **')
1200 FORMAT(/5X,'( FORWARD TRANSFORM )'/)
1300 FORMAT(/5X,'( BACKWARD TRANSFORM )'/)
1400 FORMAT(5X,'IERR = ',I5// &
 5X,'SOLUTION'/)
2000 FORMAT(7X,'REAL PART',16X,'IMAGINARY PART')
2100 FORMAT(7X,' C(',I2,') = ',F9.5,6X,' C(',I2,') = ',F9.5)
END
